/**
 *  Sankey Diagram Generator
 *  by Sam Brenner
 *  http://www.sjbrenner.com
 *  February 23, 2009
 *  v0.6
 *
 *  I'm new to this open-source code thing, so I feel this is appropriate - I'm licensing this under the terms
 *  specified here: http://creativecommons.org/licenses/by-sa/3.0/us/. No attribution is necessary, though I
 *  would appreciate it if any redistributions or implementations retain this block of code up here. Also,
 *  if anyone does anything cool with this, let me know!
 */

import proxml.*;
import processing.pdf.*;

XMLInOut xmlInOut;
color[] colorArray;
ArrayList endText;
ArrayList endStartPoints;
float lowEndpointStartY;
float highEndpointStartY;
int deepestLevel, allChildrenTotal, childCounter;

int startX = 100;               //starting point along X axis
int curveOffset = 90;          //remap value for the ends of the curves. higher values will spread apart more
int altCurveOffset = 60;       //in case you need another curve value
int bezierOffset = 50;         //length of the bezier control points
int branchWidth = 300;          //width of each bezier curve
float pinchIn = 1.0;            //increments curveOffset each node
float valueMultiplier = 1;   //multiplier for each XML node's value attribute
PFont din;
EndTextDrawer endTextDrawer;

void setup()
{
 size( 1700, 1000 );
 background( 255 );
 smooth();
 
 lowEndpointStartY = 10000;
 highEndpointStartY = 0;
 deepestLevel = 0;
 endText = new ArrayList();
 endStartPoints = new ArrayList();
  
  
 loadData();
}

void loadData()
{
  din = loadFont( "DIN-Light-8.vlw" );
    
  xmlInOut = new XMLInOut( this );
  xmlInOut.loadElement( "test.xml" );  
}

void xmlEvent( proxml.XMLElement element )
{
  allChildrenTotal = element.countAllChildren();
  //allChildrenTotal = 76; //figure this out
  childCounter = 0;
  setupColorArray( element.countChildren() );
  
  
  //beginRecord(PDF, "Lines.pdf");
  BranchGroup temp = new BranchGroup( element, 0, 500, 0, "" );
}

void setupColorArray( int numChildren )
{
  colorArray = new color[ numChildren ];
  colorMode( HSB, 100 );
  
  for( int i = 50; i < 50+numChildren; i++ )
  {
    colorArray[ i-50 ] = color( i, 100, 100 );
  } 
}

void draw()
{
  
}

void mousePressed() 
{
  //endRecord();
  save("test.tif");
}
